
$LogWriter::CommonPath = "config/server/LogWriter/";


$LogWriter::fileList0 = "bans";
$LogWriter::fileList1 = "unbans";
$LogWriter::fileList2 = "chat";
$LogWriter::fileList3 = "connections";
//$LogWriter::fileList5 = "ban_expire";
//$LogWriter::fileList6 = "staff_status";
//$LogWriter::fileList7 = "admin_teleport";

$LogWriter::fileListCount = 4;

for(%cn = 0; %cn < $LogWriter::fileListCount; %cn++)
	$LogWriter::path[$LogWriter::fileList[%cn]] = $LogWriter::fileList[%cn];


//if counter is blank (not yet set), set to 0
if($LogWriter_counter == 0)
	$LogWriter_counter = 0;

function LogWriter_addTime()
{
	%getTime = firstWord(getDateTime()) TAB restWords(getDateTime());
	return %getTime;
}

function LogWriter_writeToFile(%log, %data)
{
	%data_len = strlen(%data);
	%final_file = $LogWriter::CommonPath @ $LogWriter::path[%log];
	%file_first = %final_file @"00.txt";
	discoverFile(%file_first);
	if((getFileLength(%file_first) + %data_len) >= (1048576-2))
	{

		for(%a = 1; %a >= 0; %a++)
		{
			if(strlen(%num = %a) == 1)
				%num = "0"@ %a;

			%file_next = %final_file @ %num @".txt";
			discoverFile(%file_next);

			if((getFileLength(%file_next) + %data_len) >= (1048576-2))
				continue;

			else
				break;
	    	}
	    	%final_file = %file_next;
	}
	else
		%final_file = %file_first;

	LogWriter_writeToFileLine(%final_file, $LogWriter_counter TAB %data);
	$LogWriter_counter += 1;
}


function LogWriter_writeToFileLine(%filepath, %crap)
{
	%file = new FileObject();
	%file.openForAppend(%filepath);
	%file.writeLine(%crap);
	%file.close();
	%file.delete();
}


function LogWriter_createHelpFile()
{
	%location = $LogWriter::CommonPath @"help.txt";

	%text0 = "Log format:";
	%text1 = "";
	%text2 = "Ban logs";
	%text3 = "Date, banner's object ID, banner's ID, banner's name, victim's BLID, victim's name, time, reason";
	%text4 = "";
	%text5 = "Unban logs";
	%text6 = "Date, unbanner's object ID, unbanner's BLID, unbanner's name, victim's BLID, victim's name, time, reason";
	%text7 = "";
	%text8 = "Connection logs";
	%text9 = "Date, C(onnect) or D(isconnect), (dis)connector's object ID, (dis)connector's BLID, (dis)connector's name, (dis)connector's IP";
	%text10 = "";
	%text11 = "Chat logs";
	%text12 = "Date, \"TEAM\" or blank field, sender's object ID, sender's BLID, sender's name, message";
	%text13 = "";

	for(%i = 0; %i < 14; %i++)
		LogWriter_writeToFileLine(%location, %text[%i]);
}

function LogWriter_onServerStart()
{
	LogWriter_createHelpFile();

	%msg = "SERVER START" TAB LogWriter_addTime() TAB "--------------------------";
	
	for(%cn = 0; %cn < $LogWriter::fileListCount; %cn++)
		LogWriter_writeToFile($LogWriter::fileList[%cn], %msg);
}

//Shortcut function for 3 fields: %client object ID, BLID and name
function LogWriter_clientFields(%client)
{
	return %client TAB %client.bl_id TAB %client.name;
}

package LogWriter
{
	//Two "watcher" functions to detect whether a chat message was successfully processed
	function chatMessageClient(%client, %sender, %voiceTag, %voicePitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10)
	{
		if(%sender != 0)
		{
			$watch_chatMessageClient_ACK = 1;
			$watch_chatMessageClient_msg = %a4;
		}

		return Parent::chatMessageClient(%client, %sender, %voiceTag, %voicePitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10);
	}

	function MiniGameSO::chatMessageAll(%obj, %sender, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10)
	{
		if(%sender != 0)
		{
			$watch_chatMessageClient_ACK = 1;
			$watch_chatMessageClient_msg = %a4;
		}

		return Parent::chatMessageAll(%obj, %sender, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10);
	}




	function GameConnection::onClientLeaveGame(%client)
	{
		Parent::onClientLeaveGame(%client);
		%type = "D";

		//What's being written to the file:
		//Date, "D", disconnector's object ID, disconnector's BLID, disconnector's name, disconnector's IP
		LogWriter_writeToFile("connections", LogWriter_addTime() TAB %type TAB LogWriter_clientFields(%client) TAB %client.getRawIP());
	}

	function GameConnection::autoAdminCheck(%client)
	{
		Parent::autoAdminCheck(%client);
		%type = "C";

		//What's being written to the file:
		//Date, "C", connector's object ID, connector's BLID, connector's name, connector's IP
		LogWriter_writeToFile("connections", LogWriter_addTime() TAB %type TAB LogWriter_clientFields(%client) TAB %client.getRawIP());
	}

	function serverCmdmessageSent(%client, %text)
	{
		$watch_chatMessageClient_ACK = 0;
		$watch_chatMessageClient_msg = "";

		Parent::serverCmdmessageSent(%client, %text);

		//What's being written to the file:
		//Date, blank field, sender's object ID, sender's BLID, sender's name, message

		%type = "";
		if($watch_chatMessageClient_ACK)
			LogWriter_writeToFile("chat", LogWriter_addTime() TAB %type TAB LogWriter_clientFields(%client) TAB $watch_chatMessageClient_msg);
	}

	function serverCmdteammessageSent(%client, %text)
	{
		$watch_chatMessageClient_ACK = 0;
		$watch_chatMessageClient_msg = "";

		Parent::serverCmdteammessageSent(%client, %text);

		//What's being written to the file:
		//Date, "TEAM", sender's object ID, sender's BLID, sender's name, message

		%type = "TEAM";
		if($watch_chatMessageClient_ACK)
			LogWriter_writeToFile("chat", LogWriter_addTime() TAB %type TAB LogWriter_clientFields(%client) TAB $watch_chatMessageClient_msg);
	}

	function servercmdUnban(%client, %positionInList)
	{
		%banCount = BanManagerSO.numBans;

		Parent::servercmdunban(%client, %positionInList);

		//Ignore if unban failed, perhaps because command is from a non-admin
		if(%banCount == BanManagerSO.numBans)
			return;


		%victimName = banManagerSO.victimName[%positionInList];
		%victimBLID = banManagerSO.victimBL_ID[%positionInList];

		if(%victimName $= "\c1BL_ID: 2180\c1\c0")
			%victimName = "";

		//What's being written to the file:
		//Date, unbanner's object ID, unbanner's BLID, unbanner's name, victim's BLID, victim's name, time, reason

		LogWriter_writeToFile("unbans", LogWriter_addTime() TAB LogWriter_clientFields(%client) TAB %victimBLID TAB %victimName);
	}

	function servercmdBan(%client, %victimID, %victimBL_ID, %banTime, %reason)
	{
	
		%isBannedBefore = getField(BanManagerSO.isBanned(%victimBL_ID), 0);
		%oldreason = getField(BanManagerSO.isBanned(%victimBL_ID), 1);
		Parent::servercmdban(%client, %victimID, %victimBL_ID, %banTime, %reason);
		%isBannedAfter = getField(BanManagerSO.isBanned(%victimBL_ID), 0);

		if(!%isBannedAfter)
			return;
		%newreason = getField(BanManagerSO.isBanned(%victimBL_ID), 1);

		//If a new ban is issued and the reason did not change, don't record.
		//detecting changes in ban length is more difficult so there is no logic to detect this
		if(%isBannedBefore && %oldreason $= %newreason)
			return;


		//It is possible to ban people with the /ban command, but they might not have their name in the server history
		//The server logs all IDs and names in each brick group so once the server is shutdown, the names disappear

		//What's being written to the file:
		//Date, banner's object ID, banner's ID, banner's name, victim's BLID, victim's name, time, reason

		LogWriter_writeToFile("bans", LogWriter_addTime() TAB LogWriter_clientFields(%client) TAB %victimID.name TAB %victimBL_ID TAB %banTime TAB %reason);
	}


};

activatePackage(LogWriter);

LogWriter_onServerStart();